

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.toservice &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../../index.html" />
    <link rel="up" title="Module code" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for pywws.toservice</h1><div class="highlight"><pre>
<span class="c">#!/usr/bin/env python</span>

<span class="sd">&quot;&quot;&quot;Post weather update to services such as Weather Underground</span>
<span class="sd">::</span>

<span class="sd">%s</span>

<span class="sd">Introduction</span>
<span class="sd">------------</span>

<span class="sd">Several organisations allow weather stations to upload data using a</span>
<span class="sd">simple HTTP &#39;POST&#39; or &#39;GET&#39; request, with the data encoded as a</span>
<span class="sd">sequence of ``key=value`` pairs separated by ``&amp;`` characters.</span>

<span class="sd">This module enables pywws to upload readings to these organisations.</span>
<span class="sd">It is highly customisable using configuration files. Each &#39;service&#39;</span>
<span class="sd">requires a configuration file and two templates in ``pywws/services``</span>
<span class="sd">(that should not need to be edited by the user) and a section in</span>
<span class="sd">``weather.ini`` containing user specific data such as your site ID and</span>
<span class="sd">password.</span>

<span class="sd">There are currently six services for which configuration files have</span>
<span class="sd">been written.</span>

<span class="sd">+-----------------------------------------------------------------------+-----------------------+--------------------------------------------------------+</span>
<span class="sd">| organisation                                                          | service name          | config file                                            |</span>
<span class="sd">+=======================================================================+=======================+========================================================+</span>
<span class="sd">| `UK Met Office &lt;http://wow.metoffice.gov.uk/&gt;`_                       | ``metoffice``         | :download:`../../pywws/services/metoffice.ini`         |</span>
<span class="sd">+-----------------------------------------------------------------------+-----------------------+--------------------------------------------------------+</span>
<span class="sd">| `Open Weather Map &lt;http://openweathermap.org/&gt;`_                      | ``openweathermap``    | :download:`../../pywws/services/openweathermap.ini`    |</span>
<span class="sd">+-----------------------------------------------------------------------+-----------------------+--------------------------------------------------------+</span>
<span class="sd">| `Stacja Pogody &lt;http://stacjapogody.waw.pl/index.php?id=mapastacji&gt;`_ | ``stacjapogodywawpl`` | :download:`../../pywws/services/stacjapogodywawpl.ini` |</span>
<span class="sd">+-----------------------------------------------------------------------+-----------------------+--------------------------------------------------------+</span>
<span class="sd">| `temperatur.nu &lt;http://www.temperatur.nu/&gt;`_                          | ``temperaturnu``      | :download:`../../pywws/services/temperaturnu.ini`      |</span>
<span class="sd">+-----------------------------------------------------------------------+-----------------------+--------------------------------------------------------+</span>
<span class="sd">| `Weather Underground &lt;http://www.wunderground.com/&gt;`_                 | ``underground``       | :download:`../../pywws/services/underground.ini`       |</span>
<span class="sd">+-----------------------------------------------------------------------+-----------------------+--------------------------------------------------------+</span>
<span class="sd">| `wetter.com &lt;http://www.wetter.com/community/&gt;`_                      | ``wetterarchivde``    | :download:`../../pywws/services/wetterarchivde.ini`    |</span>
<span class="sd">+-----------------------------------------------------------------------+-----------------------+--------------------------------------------------------+</span>

<span class="sd">Configuration</span>
<span class="sd">-------------</span>

<span class="sd">If you haven&#39;t already done so, visit the organisation&#39;s web site and</span>
<span class="sd">create an account for your weather station. Make a note of any site ID</span>
<span class="sd">and password details you are given.</span>

<span class="sd">Stop any pywws software that is running and then run ``toservice.py``</span>
<span class="sd">to create a section in ``weather.ini``::</span>

<span class="sd">    python pywws/toservice.py data_dir service_name</span>

<span class="sd">``service_name`` is a single word service name, such as ``metoffice``,</span>
<span class="sd">``data_dir`` is your weather data directory, as usual.</span>

<span class="sd">Edit ``weather.ini`` and find the section corresponding to the service</span>
<span class="sd">name, e.g. ``[underground]``. Copy your site details into this</span>
<span class="sd">section, for example::</span>

<span class="sd">    [underground]</span>
<span class="sd">    password = secret</span>
<span class="sd">    station = ABCDEFG1A</span>

<span class="sd">Now you can test your configuration::</span>

<span class="sd">    python pywws/toservice.py -vvv data_dir service_name</span>

<span class="sd">This should show you the data string that is uploaded. Any failure</span>
<span class="sd">should generate an error message.</span>

<span class="sd">Upload old data</span>
<span class="sd">---------------</span>

<span class="sd">Now you can upload your last 7 days&#39; data, if the service supports it.</span>
<span class="sd">Edit your ``weather.ini`` file and remove the ``last update`` line</span>
<span class="sd">from the appropriate section, then run ``toservice.py`` with the</span>
<span class="sd">catchup option::</span>

<span class="sd">    python pywws/toservice.py -cvv data_dir service_name</span>

<span class="sd">This may take 20 minutes or more, depending on how much data you have.</span>

<span class="sd">Add service(s) upload to regular tasks</span>
<span class="sd">--------------------------------------</span>

<span class="sd">Edit your ``weather.ini`` again, and add a list of services to the</span>
<span class="sd">``[live]``, ``[logged]``, ``[hourly]``, ``[12 hourly]`` or ``[daily]``</span>
<span class="sd">section, depending on how often you want to send data. For example::</span>

<span class="sd">    [live]</span>
<span class="sd">    twitter = []</span>
<span class="sd">    plot = []</span>
<span class="sd">    text = []</span>
<span class="sd">    services = [&#39;underground&#39;]</span>

<span class="sd">    [logged]</span>
<span class="sd">    twitter = []</span>
<span class="sd">    plot = []</span>
<span class="sd">    text = []</span>
<span class="sd">    services = [&#39;metoffice&#39;, &#39;stacjapogodywawpl&#39;]</span>

<span class="sd">    [hourly]</span>
<span class="sd">    twitter = []</span>
<span class="sd">    plot = []</span>
<span class="sd">    text = []</span>
<span class="sd">    services = [&#39;underground&#39;]</span>

<span class="sd">Note that the ``[live]`` section is only used when running</span>
<span class="sd">``LiveLog.py``. It is a good idea to repeat any service selected in</span>
<span class="sd">``[live]`` in the ``[logged]`` or ``[hourly]`` section in case you</span>
<span class="sd">switch to running :mod:`Hourly`.</span>

<span class="sd">Restart your regular pywws program (:mod:`Hourly` or :mod:`LiveLog`)</span>
<span class="sd">and visit the appropriate web site to see regular updates from your</span>
<span class="sd">weather station.</span>

<span class="sd">Notes on the services</span>
<span class="sd">---------------------</span>

<span class="sd">UK Met Office</span>
<span class="sd">=============</span>

<span class="sd">* Create account: https://register.metoffice.gov.uk/WaveRegistrationClient/public/register.do?service=weatherobservations</span>
<span class="sd">* API: http://wow.metoffice.gov.uk/support?category=dataformats#automatic</span>
<span class="sd">* Example ``weather.ini`` section::</span>

<span class="sd">    [metoffice]</span>
<span class="sd">    site id = 12345678</span>
<span class="sd">    aws pin = 987654</span>

<span class="sd">Open Weather Map</span>
<span class="sd">================</span>

<span class="sd">* Create account: http://openweathermap.org/login</span>
<span class="sd">* API: http://openweathermap.org/API</span>
<span class="sd">* Example ``weather.ini`` section::</span>

<span class="sd">    [openweathermap]</span>
<span class="sd">    lat = 51.501</span>
<span class="sd">    long = -0.142</span>
<span class="sd">    alt = 10</span>
<span class="sd">    user = Elizabeth Windsor</span>
<span class="sd">    password = corgi</span>
<span class="sd">    id = Buck House</span>

<span class="sd">The default behaviour is to use your user name to identify the weather</span>
<span class="sd">station. However, it&#39;s possible for a user to have more than one</span>
<span class="sd">weather station, so there is an undocumented ``name`` parameter in the</span>
<span class="sd">API that can be used to identify the station. This appears as ``id``</span>
<span class="sd">in ``weather.ini``. Make sure you don&#39;t choose a name that is already</span>
<span class="sd">in use.</span>

<span class="sd">Weather Underground</span>
<span class="sd">===================</span>

<span class="sd">* Create account: http://www.wunderground.com/members/signup.asp</span>
<span class="sd">* API: http://wiki.wunderground.com/index.php/PWS_-_Upload_Protocol</span>
<span class="sd">* Example ``weather.ini`` section::</span>

<span class="sd">    [underground]</span>
<span class="sd">    station = ABCDEFGH1</span>
<span class="sd">    password = xxxxxxx</span>

<span class="sd">API</span>
<span class="sd">---</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__docformat__</span> <span class="o">=</span> <span class="s">&quot;restructuredtext en&quot;</span>
<span class="n">__usage__</span> <span class="o">=</span> <span class="s">&quot;&quot;&quot;</span>
<span class="s"> usage: python toservice.py [options] data_dir service_name</span>
<span class="s"> options are:</span>
<span class="s">  -h or --help     display this help</span>
<span class="s">  -c or --catchup  upload all data since last upload</span>
<span class="s">  -v or --verbose  increase amount of reassuring messages</span>
<span class="s"> data_dir is the root directory of the weather data</span>
<span class="s"> service_name is the service to upload to, e.g. underground</span>
<span class="s">&quot;&quot;&quot;</span>
<span class="n">__doc__</span> <span class="o">%=</span> <span class="n">__usage__</span>
<span class="n">__usage__</span> <span class="o">=</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">__usage__</span>

<span class="kn">from</span> <span class="nn">ConfigParser</span> <span class="kn">import</span> <span class="n">SafeConfigParser</span>
<span class="kn">import</span> <span class="nn">getopt</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">socket</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">urllib</span>
<span class="kn">import</span> <span class="nn">urllib2</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span><span class="p">,</span> <span class="n">timedelta</span>

<span class="kn">import</span> <span class="nn">DataStore</span>
<span class="kn">from</span> <span class="nn">Logger</span> <span class="kn">import</span> <span class="n">ApplicationLogger</span>
<span class="kn">import</span> <span class="nn">Template</span>

<span class="n">FIVE_MINS</span> <span class="o">=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">minutes</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>

<div class="viewcode-block" id="ToService"><a class="viewcode-back" href="../../api/pywws.toservice.html#pywws.toservice.ToService">[docs]</a><span class="k">class</span> <span class="nc">ToService</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Upload weather data to weather services such as Weather</span>
<span class="sd">    Underground.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">calib_data</span><span class="p">,</span> <span class="n">service_name</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        :param params: pywws configuration.</span>

<span class="sd">        :type params: :class:`pywws.DataStore.params`</span>
<span class="sd">        </span>
<span class="sd">        :param calib_data: &#39;calibrated&#39; data.</span>

<span class="sd">        :type calib_data: :class:`pywws.DataStore.calib_store`</span>

<span class="sd">        :keyword service_name: name of service to upload to.</span>

<span class="sd">        :type service_name: string</span>
<span class="sd">    </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">service_name</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">config_section</span> <span class="o">=</span> <span class="n">service_name</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span>
                <span class="s">&#39;pywws.ToService(</span><span class="si">%s</span><span class="s">)&#39;</span> <span class="o">%</span> <span class="n">service_name</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span>
                <span class="s">&#39;pywws.</span><span class="si">%s</span><span class="s">&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">__class__</span><span class="o">.</span><span class="n">__name__</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">params</span> <span class="o">=</span> <span class="n">params</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">calib_data</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">old_response</span> <span class="o">=</span> <span class="bp">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">old_ex</span> <span class="o">=</span> <span class="bp">None</span>
        <span class="c"># set default socket timeout, so urlopen calls don&#39;t hang forever</span>
        <span class="n">socket</span><span class="o">.</span><span class="n">setdefaulttimeout</span><span class="p">(</span><span class="mi">30</span><span class="p">)</span>
        <span class="c"># open params file</span>
        <span class="n">service_params</span> <span class="o">=</span> <span class="n">SafeConfigParser</span><span class="p">()</span>
        <span class="n">service_params</span><span class="o">.</span><span class="n">optionxform</span> <span class="o">=</span> <span class="nb">str</span>
        <span class="n">service_params</span><span class="o">.</span><span class="n">readfp</span><span class="p">(</span><span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span>
            <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">__file__</span><span class="p">),</span> <span class="s">&#39;services&#39;</span><span class="p">,</span>
            <span class="s">&#39;</span><span class="si">%s</span><span class="s">.ini&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">config_section</span><span class="p">))))</span>
        <span class="c"># get URL</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">server</span> <span class="o">=</span> <span class="n">service_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;url&#39;</span><span class="p">)</span>
        <span class="c"># get fixed part of upload data</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">service_params</span><span class="o">.</span><span class="n">items</span><span class="p">(</span><span class="s">&#39;fixed&#39;</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">value</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s">&#39;*&#39;</span><span class="p">:</span>
                <span class="n">value</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">config_section</span><span class="p">,</span> <span class="n">value</span><span class="p">[</span><span class="mi">1</span><span class="p">:],</span> <span class="s">&#39;unknown&#39;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>
        <span class="c"># create templater</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">templater</span> <span class="o">=</span> <span class="n">Template</span><span class="o">.</span><span class="n">Template</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">data</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">data</span><span class="p">,</span> <span class="bp">None</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">template_file</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span>
            <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">__file__</span><span class="p">),</span> <span class="s">&#39;services&#39;</span><span class="p">,</span>
            <span class="s">&#39;</span><span class="si">%s</span><span class="s">_template_</span><span class="si">%s</span><span class="s">.txt&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">service_name</span><span class="p">,</span>
                                    <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;fixed&#39;</span><span class="p">,</span> <span class="s">&#39;ws type&#39;</span><span class="p">)))</span>
        <span class="c"># get other parameters</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">catchup</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">service_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;catchup&#39;</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">use_get</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">service_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;use get&#39;</span><span class="p">))</span>
        <span class="n">rapid_fire</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">service_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;rapidfire&#39;</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">rapid_fire</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">server_rf</span> <span class="o">=</span> <span class="n">service_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;url-rf&#39;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data_rf</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fixed_data</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">service_params</span><span class="o">.</span><span class="n">items</span><span class="p">(</span><span class="s">&#39;fixed-rf&#39;</span><span class="p">):</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data_rf</span><span class="p">[</span><span class="n">name</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">server_rf</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">server</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data_rf</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">expected_result</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">service_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;result&#39;</span><span class="p">))</span>

<div class="viewcode-block" id="ToService.translate_data"><a class="viewcode-back" href="../../api/pywws.toservice.html#pywws.toservice.ToService.translate_data">[docs]</a>    <span class="k">def</span> <span class="nf">translate_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">current</span><span class="p">,</span> <span class="n">fixed_data</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Convert a weather data record to upload format.</span>

<span class="sd">        The :obj:`current` parameter contains the data to be uploaded.</span>
<span class="sd">        It should be a &#39;calibrated&#39; data record, as stored in</span>
<span class="sd">        :class:`pywws.DataStore.calib_store`.</span>

<span class="sd">        The :obj:`fixed_data` parameter contains unvarying data that</span>
<span class="sd">        is site dependent, for example an ID code and authentication</span>
<span class="sd">        data.</span>

<span class="sd">        :param current: the weather data record.</span>

<span class="sd">        :type current: dict</span>

<span class="sd">        :param fixed_data: unvarying upload data.</span>

<span class="sd">        :type fixed_data: dict</span>

<span class="sd">        :return: converted data, or :obj:`None` if invalid data.</span>

<span class="sd">        :rtype: dict(string)</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c"># check we have enough data</span>
        <span class="k">if</span> <span class="n">current</span><span class="p">[</span><span class="s">&#39;temp_out&#39;</span><span class="p">]</span> <span class="ow">is</span> <span class="bp">None</span> <span class="ow">or</span> <span class="n">current</span><span class="p">[</span><span class="s">&#39;hum_out&#39;</span><span class="p">]</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">None</span>
        <span class="c"># convert data</span>
        <span class="n">result</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="n">fixed_data</span><span class="p">)</span>
        <span class="n">template_data</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">templater</span><span class="o">.</span><span class="n">make_text</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">template_file</span><span class="p">,</span> <span class="n">current</span><span class="p">)</span>
        <span class="n">result</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="nb">eval</span><span class="p">(</span><span class="n">template_data</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">result</span>
</div>
<div class="viewcode-block" id="ToService.send_data"><a class="viewcode-back" href="../../api/pywws.toservice.html#pywws.toservice.ToService.send_data">[docs]</a>    <span class="k">def</span> <span class="nf">send_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">server</span><span class="p">,</span> <span class="n">fixed_data</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Upload a weather data record.</span>

<span class="sd">        The :obj:`data` parameter contains the data to be uploaded.</span>
<span class="sd">        It should be a &#39;calibrated&#39; data record, as stored in</span>
<span class="sd">        :class:`pywws.DataStore.calib_store`.</span>

<span class="sd">        The :obj:`fixed_data` parameter contains unvarying data that</span>
<span class="sd">        is site dependent, for example an ID code and authentication</span>
<span class="sd">        data.</span>

<span class="sd">        :param data: the weather data record.</span>

<span class="sd">        :type data: dict</span>

<span class="sd">        :param server: web address to upload to.</span>

<span class="sd">        :type server: string</span>

<span class="sd">        :param fixed_data: unvarying upload data.</span>

<span class="sd">        :type fixed_data: dict</span>

<span class="sd">        :return: success status</span>

<span class="sd">        :rtype: bool</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">coded_data</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">translate_data</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="n">fixed_data</span><span class="p">)</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">coded_data</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">True</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="n">coded_data</span><span class="p">)</span>
        <span class="n">coded_data</span> <span class="o">=</span> <span class="n">urllib</span><span class="o">.</span><span class="n">urlencode</span><span class="p">(</span><span class="n">coded_data</span><span class="p">)</span>
        <span class="c"># have three tries before giving up</span>
        <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">3</span><span class="p">):</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">sys</span><span class="o">.</span><span class="n">hexversion</span> <span class="o">&lt;=</span> <span class="mh">0x020406ff</span><span class="p">:</span>
                    <span class="n">wudata</span> <span class="o">=</span> <span class="n">urllib</span><span class="o">.</span><span class="n">urlopen</span><span class="p">(</span><span class="s">&#39;</span><span class="si">%s</span><span class="s">?</span><span class="si">%s</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">server</span><span class="p">,</span> <span class="n">coded_data</span><span class="p">))</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">try</span><span class="p">:</span>
                        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">use_get</span><span class="p">:</span>
                            <span class="n">wudata</span> <span class="o">=</span> <span class="n">urllib2</span><span class="o">.</span><span class="n">urlopen</span><span class="p">(</span>
                                <span class="s">&#39;</span><span class="si">%s</span><span class="s">?</span><span class="si">%s</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">server</span><span class="p">,</span> <span class="n">coded_data</span><span class="p">))</span>
                        <span class="k">else</span><span class="p">:</span>
                            <span class="n">wudata</span> <span class="o">=</span> <span class="n">urllib2</span><span class="o">.</span><span class="n">urlopen</span><span class="p">(</span><span class="n">server</span><span class="p">,</span> <span class="n">coded_data</span><span class="p">)</span>
                    <span class="k">except</span> <span class="n">urllib2</span><span class="o">.</span><span class="n">HTTPError</span><span class="p">,</span> <span class="n">ex</span><span class="p">:</span>
                        <span class="k">if</span> <span class="n">ex</span><span class="o">.</span><span class="n">code</span> <span class="o">!=</span> <span class="mi">400</span><span class="p">:</span>
                            <span class="k">raise</span>
                        <span class="n">wudata</span> <span class="o">=</span> <span class="n">ex</span>
                <span class="n">response</span> <span class="o">=</span> <span class="n">wudata</span><span class="o">.</span><span class="n">readlines</span><span class="p">()</span>
                <span class="n">wudata</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">response</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">expected_result</span><span class="p">):</span>
                    <span class="k">for</span> <span class="n">actual</span><span class="p">,</span> <span class="n">expected</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">response</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">expected_result</span><span class="p">):</span>
                        <span class="k">if</span> <span class="ow">not</span> <span class="n">re</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">expected</span><span class="p">,</span> <span class="n">actual</span><span class="p">):</span>
                            <span class="k">break</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">old_response</span> <span class="o">=</span> <span class="n">response</span>
                        <span class="k">return</span> <span class="bp">True</span>
                <span class="k">if</span> <span class="n">response</span> <span class="o">!=</span> <span class="bp">self</span><span class="o">.</span><span class="n">old_response</span><span class="p">:</span>
                    <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">response</span><span class="p">:</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">line</span><span class="o">.</span><span class="n">strip</span><span class="p">())</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">old_response</span> <span class="o">=</span> <span class="n">response</span>
            <span class="k">except</span> <span class="ne">Exception</span><span class="p">,</span> <span class="n">ex</span><span class="p">:</span>
                <span class="n">e</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">ex</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">e</span> <span class="o">!=</span> <span class="bp">self</span><span class="o">.</span><span class="n">old_ex</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">e</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">old_ex</span> <span class="o">=</span> <span class="n">e</span>
        <span class="k">return</span> <span class="bp">False</span>
</div>
<div class="viewcode-block" id="ToService.Upload"><a class="viewcode-back" href="../../api/pywws.toservice.html#pywws.toservice.ToService.Upload">[docs]</a>    <span class="k">def</span> <span class="nf">Upload</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">catchup</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Upload one or more weather data records.</span>

<span class="sd">        This method uploads either the most recent weather data</span>
<span class="sd">        record, or all records since the last upload (up to 7 days),</span>
<span class="sd">        according to the value of :obj:`catchup`.</span>

<span class="sd">        It sets the ``last update`` configuration value to the time</span>
<span class="sd">        stamp of the most recent record successfully uploaded.</span>

<span class="sd">        :param catchup: upload all data since last upload.</span>

<span class="sd">        :type catchup: bool</span>

<span class="sd">        :return: success status</span>

<span class="sd">        :rtype: bool</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">catchup</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">catchup</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">start</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">utcnow</span><span class="p">()</span> <span class="o">-</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">days</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">catchup</span><span class="p">)</span>
            <span class="n">last_update</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">get_datetime</span><span class="p">(</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">config_section</span><span class="p">,</span> <span class="s">&#39;last update&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">last_update</span><span class="p">:</span>
                <span class="n">start</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">start</span><span class="p">,</span> <span class="n">last_update</span> <span class="o">+</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">minutes</span><span class="o">=</span><span class="mi">1</span><span class="p">))</span>
            <span class="n">count</span> <span class="o">=</span> <span class="mi">0</span>
            <span class="k">for</span> <span class="n">data</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">data</span><span class="p">[</span><span class="n">start</span><span class="p">:]:</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">send_data</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">server</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data</span><span class="p">):</span>
                    <span class="k">return</span> <span class="bp">False</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">set</span><span class="p">(</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">config_section</span><span class="p">,</span> <span class="s">&#39;last update&#39;</span><span class="p">,</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">isoformat</span><span class="p">(</span><span class="s">&#39; &#39;</span><span class="p">))</span>
                <span class="n">count</span> <span class="o">+=</span> <span class="mi">1</span>
            <span class="k">if</span> <span class="n">count</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s">&#39;</span><span class="si">%d</span><span class="s"> records sent&#39;</span><span class="p">,</span> <span class="n">count</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="c"># upload most recent data</span>
            <span class="n">last_update</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">before</span><span class="p">(</span><span class="n">datetime</span><span class="o">.</span><span class="n">max</span><span class="p">)</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">send_data</span><span class="p">(</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">data</span><span class="p">[</span><span class="n">last_update</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">server</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data</span><span class="p">):</span>
                <span class="k">return</span> <span class="bp">False</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">set</span><span class="p">(</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">config_section</span><span class="p">,</span> <span class="s">&#39;last update&#39;</span><span class="p">,</span> <span class="n">last_update</span><span class="o">.</span><span class="n">isoformat</span><span class="p">(</span><span class="s">&#39; &#39;</span><span class="p">))</span>
        <span class="k">return</span> <span class="bp">True</span>
</div>
<div class="viewcode-block" id="ToService.RapidFire"><a class="viewcode-back" href="../../api/pywws.toservice.html#pywws.toservice.ToService.RapidFire">[docs]</a>    <span class="k">def</span> <span class="nf">RapidFire</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">catchup</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Upload a &#39;Rapid Fire&#39; weather data record.</span>

<span class="sd">        This method uploads either a single data record (typically one</span>
<span class="sd">        obtained during &#39;live&#39; logging), or all records since the last</span>
<span class="sd">        upload (up to 7 days), according to the value of</span>
<span class="sd">        :obj:`catchup`.</span>

<span class="sd">        It sets the ``last update`` configuration value to the time</span>
<span class="sd">        stamp of the most recent record successfully uploaded.</span>

<span class="sd">        The :obj:`data` parameter contains the data to be uploaded.</span>
<span class="sd">        It should be a &#39;calibrated&#39; data record, as stored in</span>
<span class="sd">        :class:`pywws.DataStore.calib_store`.</span>

<span class="sd">        :param data: the weather data record.</span>

<span class="sd">        :type data: dict</span>

<span class="sd">        :param catchup: upload all data since last upload.</span>

<span class="sd">        :type catchup: bool</span>

<span class="sd">        :return: success status</span>

<span class="sd">        :rtype: bool</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">last_log</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">before</span><span class="p">(</span><span class="n">datetime</span><span class="o">.</span><span class="n">max</span><span class="p">)</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">last_log</span> <span class="ow">or</span> <span class="n">last_log</span> <span class="o">&lt;</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span> <span class="o">-</span> <span class="n">FIVE_MINS</span><span class="p">:</span>
            <span class="c"># logged data is not (yet) up to date</span>
            <span class="k">return</span> <span class="bp">True</span>
        <span class="k">if</span> <span class="n">catchup</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">catchup</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">last_update</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">get_datetime</span><span class="p">(</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">config_section</span><span class="p">,</span> <span class="s">&#39;last update&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">last_update</span><span class="p">:</span>
                <span class="n">last_update</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">min</span>
            <span class="k">if</span> <span class="n">last_update</span> <span class="o">&lt;=</span> <span class="n">last_log</span> <span class="o">-</span> <span class="n">FIVE_MINS</span><span class="p">:</span>
                <span class="c"># last update was well before last logged data</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">Upload</span><span class="p">(</span><span class="bp">True</span><span class="p">):</span>
                    <span class="k">return</span> <span class="bp">False</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">send_data</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">server_rf</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">fixed_data_rf</span><span class="p">):</span>
            <span class="k">return</span> <span class="bp">False</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="o">.</span><span class="n">set</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">config_section</span><span class="p">,</span> <span class="s">&#39;last update&#39;</span><span class="p">,</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">isoformat</span><span class="p">(</span><span class="s">&#39; &#39;</span><span class="p">))</span>
        <span class="k">return</span> <span class="bp">True</span>
</div></div>
<div class="viewcode-block" id="main"><a class="viewcode-back" href="../../api/pywws.toservice.html#pywws.toservice.main">[docs]</a><span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">argv</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">argv</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
        <span class="n">argv</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">opts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">getopt</span><span class="o">.</span><span class="n">getopt</span><span class="p">(</span>
            <span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:],</span> <span class="s">&quot;hcv&quot;</span><span class="p">,</span> <span class="p">[</span><span class="s">&#39;help&#39;</span><span class="p">,</span> <span class="s">&#39;catchup&#39;</span><span class="p">,</span> <span class="s">&#39;verbose&#39;</span><span class="p">])</span>
    <span class="k">except</span> <span class="n">getopt</span><span class="o">.</span><span class="n">error</span><span class="p">,</span> <span class="n">msg</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">msg</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">1</span>
    <span class="c"># process options</span>
    <span class="n">catchup</span> <span class="o">=</span> <span class="bp">False</span>
    <span class="n">verbose</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">for</span> <span class="n">o</span><span class="p">,</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">opts</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;-h&#39;</span> <span class="ow">or</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;--help&#39;</span><span class="p">:</span>
            <span class="k">print</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="k">return</span> <span class="mi">0</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;-c&#39;</span> <span class="ow">or</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;--catchup&#39;</span><span class="p">:</span>
            <span class="n">catchup</span> <span class="o">=</span> <span class="bp">True</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;-v&#39;</span> <span class="ow">or</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;--verbose&#39;</span><span class="p">:</span>
            <span class="n">verbose</span> <span class="o">+=</span> <span class="mi">1</span>
    <span class="c"># check arguments</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">2</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&quot;Error: 2 arguments required&quot;</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">2</span>
    <span class="n">logger</span> <span class="o">=</span> <span class="n">ApplicationLogger</span><span class="p">(</span><span class="n">verbose</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">ToService</span><span class="p">(</span>
        <span class="n">DataStore</span><span class="o">.</span><span class="n">params</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span> <span class="n">DataStore</span><span class="o">.</span><span class="n">calib_store</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span>
        <span class="n">service_name</span><span class="o">=</span><span class="n">args</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
        <span class="p">)</span><span class="o">.</span><span class="n">Upload</span><span class="p">(</span><span class="n">catchup</span><span class="p">)</span>
</div>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="n">main</span><span class="p">())</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>